diff --git a/src/backend/port/sysv_shmem.c b/src/backend/port/sysv_shmem.c
index 2e3886cf9fe..c052776e94c 100644
--- a/src/backend/port/sysv_shmem.c
+++ b/src/backend/port/sysv_shmem.c
@@ -589,44 +589,113 @@ check_huge_page_size(int *newval, void **extra, GucSource source)
 	return true;
 }
 
+/*
+ * Get the page size being used by the shared memory.
+ *
+ * The function should be called only after the shared memory has been setup.
+ */
+size_t
+GetOSPageSize(void)
+{
+	size_t		os_page_size;
+
+	Assert(huge_pages_status != HUGE_PAGES_UNKNOWN);
+
+	os_page_size = sysconf(_SC_PAGESIZE);
+
+	/* If huge pages are actually in use, use huge page size */
+	if (huge_pages_status == HUGE_PAGES_ON)
+		GetHugePageSize(&os_page_size, NULL);
+
+	return os_page_size;
+}
+
 /*
  * Creates an anonymous mmap()ed shared memory segment.
  *
- * Pass the requested size in *size.  This function will modify *size to the
- * actual size of the allocation, if it ends up allocating a segment that is
- * larger than requested.
+ * initial_size is the amount of memory required at the start of the server.
+ *
+ * *size is the size of the anonymous memory mapping to create. It will be
+ * updated to the actual size of the allocation, if it ends up allocating a
+ * segment that is larger than the requested. When *size > initial_size we want
+ * to reserve a large memory segment while allocating only initial_size amount of
+ * memory at the server start.
+ *
+ * When using huge pages, we make sure that there are enough huge pages
+ * configured to cover the initial_size worth of memory.
  */
 static void *
-CreateAnonymousSegment(Size *size)
+CreateAnonymousSegment(Size initial_size, Size *size)
 {
 	Size		allocsize = *size;
 	void	   *ptr = MAP_FAILED;
 	int			mmap_errno = 0;
+	bool		resizable = (initial_size < allocsize);
 	int			mmap_flags = MAP_SHARED | MAP_ANONYMOUS | MAP_HASSEMAPHORE;
 
+	Assert(initial_size <= allocsize);
+
 #ifndef MAP_HUGETLB
 	/* PGSharedMemoryCreate should have dealt with this case */
 	Assert(huge_pages != HUGE_PAGES_ON);
 #else
 	if (huge_pages == HUGE_PAGES_ON || huge_pages == HUGE_PAGES_TRY)
 	{
-		/*
-		 * Round up the request size to a suitable large value.
-		 */
 		Size		hugepagesize;
 		int			huge_mmap_flags;
+		bool		probe_ok = true;
 
+		/* Round up the request size to a suitable large value. */
 		GetHugePageSize(&hugepagesize, &huge_mmap_flags);
-
 		if (allocsize % hugepagesize != 0)
 			allocsize = add_size(allocsize, hugepagesize - (allocsize % hugepagesize));
+		if (initial_size % hugepagesize != 0)
+			initial_size = add_size(initial_size, hugepagesize - (initial_size % hugepagesize));
 
-		ptr = mmap(NULL, allocsize, PROT_READ | PROT_WRITE,
-				   mmap_flags | huge_mmap_flags, -1, 0);
-		mmap_errno = errno;
-		if (huge_pages == HUGE_PAGES_TRY && ptr == MAP_FAILED)
-			elog(DEBUG1, "mmap(%zu) with MAP_HUGETLB failed, huge pages disabled: %m",
-				 allocsize);
+		/*
+		 * When the total amount of space requested is larger than the initial
+		 * memory requirement, we do not allocate memory worth the entire
+		 * requested space upfront. But we will need to make sure that there
+		 * are enough huge pages configured to cover the initial memory
+		 * requirement. Otherwise, we will choose huge pages map instead of
+		 * falling back to normal pages and the server will not start. Hence
+		 * we first try to map and allocate the initial memory requirement. If
+		 * it fails we fall back to normal pages. If it succeeds, we unmap the
+		 * memory and then try to map the entire requested space without
+		 * allocating memory.
+		 */
+		if (resizable)
+		{
+			void	   *probe;
+
+			probe = mmap(NULL, initial_size, PROT_READ | PROT_WRITE,
+						 mmap_flags | huge_mmap_flags,
+						 -1, 0);
+			if (probe == MAP_FAILED)
+			{
+				mmap_errno = errno;
+				probe_ok = false;
+				if (huge_pages == HUGE_PAGES_TRY)
+					elog(DEBUG1,
+						 "huge-page probe mmap(%zu) failed, huge pages disabled: %m",
+						 initial_size);
+			}
+			else if (munmap(probe, initial_size) != 0)
+				elog(ERROR, "munmap(%p, %zu) huge page probe failed: %m", probe, initial_size);
+		}
+
+		if (probe_ok)
+		{
+			if (resizable)
+				mmap_flags |= MAP_NORESERVE;
+			ptr = mmap(NULL, allocsize, PROT_READ | PROT_WRITE,
+					   mmap_flags | huge_mmap_flags, -1, 0);
+			mmap_errno = errno;
+			if (huge_pages == HUGE_PAGES_TRY && ptr == MAP_FAILED)
+				elog(DEBUG1,
+					 "mmap(%zu) with MAP_HUGETLB failed, huge pages disabled: %m",
+					 allocsize);
+		}
 	}
 #endif
 
@@ -645,6 +714,10 @@ CreateAnonymousSegment(Size *size)
 		 * to non-huge pages.
 		 */
 		allocsize = *size;
+
+		/* Use MAP_NORESERVE when we do not need all the memory up front. */
+		if (resizable)
+			mmap_flags |= MAP_NORESERVE;
 		ptr = mmap(NULL, allocsize, PROT_READ | PROT_WRITE,
 				   mmap_flags, -1, 0);
 		mmap_errno = errno;
@@ -693,13 +766,18 @@ AnonymousShmemDetach(int status, Datum arg)
  * standard header.  Also, register an on_shmem_exit callback to release
  * the storage.
  *
+ * initial_size is the amount of memory required at the start of the server.
+ * Used only when we want to reserve a large memory segment while allocating
+ * only initial_size amount of memory at the server start. That facility is only
+ * available when using anonymous shared memory segments.
+ *
  * Dead Postgres segments pertinent to this DataDir are recycled if found, but
  * we do not fail upon collision with foreign shmem segments.  The idea here
  * is to detect and re-use keys that may have been assigned by a crashed
  * postmaster or backend.
  */
 PGShmemHeader *
-PGSharedMemoryCreate(Size size,
+PGSharedMemoryCreate(Size initial_size, Size size,
 					 PGShmemHeader **shim)
 {
 	IpcMemoryKey NextShmemSegID;
@@ -738,7 +816,7 @@ PGSharedMemoryCreate(Size size,
 
 	if (shared_memory_type == SHMEM_TYPE_MMAP)
 	{
-		AnonymousShmem = CreateAnonymousSegment(&size);
+		AnonymousShmem = CreateAnonymousSegment(initial_size, &size);
 		AnonymousShmemSize = size;
 
 		/* Register on-exit routine to unmap the anonymous segment */
@@ -754,6 +832,10 @@ PGSharedMemoryCreate(Size size,
 		/* huge pages are only available with mmap */
 		SetConfigOption("huge_pages_status", "off",
 						PGC_INTERNAL, PGC_S_DYNAMIC_DEFAULT);
+
+		/* resizable shared memory is only available with mmap */
+		SetConfigOption("have_resizable_shmem", "off",
+						PGC_INTERNAL, PGC_S_DYNAMIC_DEFAULT);
 	}
 
 	/*
@@ -991,3 +1073,148 @@ PGSharedMemoryDetach(void)
 		AnonymousShmem = NULL;
 	}
 }
+
+/*
+ * Make sure that the memory of given size from the given address is released.
+ *
+ * The address and size are expected to be page aligned.
+ *
+ * Only supported on platforms that support anonymous shared memory.
+ *
+ * On success returns true. false if system call fails.
+ */
+bool
+PGSharedMemoryEnsureFreed(void *addr, Size size)
+{
+#ifndef HAVE_RESIZABLE_SHMEM
+	ereport(ERROR,
+			errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+			errmsg("resizable shared memory is not supported on this platform"));
+#else
+	if (!AnonymousShmem)
+		ereport(ERROR,
+				errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+				errmsg("only anonymous shared memory can be freed"));
+
+#ifdef USE_ASSERT_CHECKING
+	{
+		size_t		os_page_size = GetOSPageSize();
+
+		Assert(addr == (void *) TYPEALIGN(os_page_size, addr));
+		Assert(size == TYPEALIGN(os_page_size, size));
+	}
+#endif
+
+	if (madvise(addr, size, MADV_REMOVE) == -1)
+	{
+		ereport(WARNING, errmsg("could not free shared memory: %m"));
+		return false;
+	}
+
+	return true;
+#endif
+}
+
+/*
+ * Make sure that the memory of given size from the given address is allocated.
+ *
+ * The address and size are expected to be page aligned.  The caller is
+ * responsible for ensuring that the range is already writable; this function
+ * only populates it.
+ *
+ * Only supported on platforms that support anonymous shared memory.
+ *
+ * On success returns true, false if system call fails.
+ */
+bool
+PGSharedMemoryEnsureAllocated(void *addr, Size size)
+{
+#ifndef HAVE_RESIZABLE_SHMEM
+	ereport(ERROR,
+			errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+			errmsg("resizable shared memory is not supported on this platform"));
+#else
+	if (!AnonymousShmem)
+		ereport(ERROR,
+				errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+				errmsg("only anonymous shared memory can be allocated at runtime"));
+
+#ifdef USE_ASSERT_CHECKING
+	{
+		size_t		os_page_size = GetOSPageSize();
+
+		Assert(addr == (void *) TYPEALIGN(os_page_size, addr));
+		Assert(size == TYPEALIGN(os_page_size, size));
+	}
+#endif
+
+	if (madvise(addr, size, MADV_POPULATE_WRITE) == -1)
+	{
+		ereport(WARNING, errmsg("could not allocate shared memory: %m"));
+		return false;
+	}
+
+	return true;
+#endif
+}
+
+/*
+ * Set memory protection on the given region of shared memory.
+ *
+ * Makes [rw_start, rw_end) readable and writable, and [rw_end, prot_end)
+ * inaccessible.
+ *
+ * All addresses are expected to be page aligned.
+ *
+ * Only supported on platforms that support resizable shared memory.
+ *
+ * On success returns true, false if system call fails.
+ */
+bool
+PGSharedMemoryProtect(void *rw_start, void *rw_end, void *prot_end)
+{
+#ifndef HAVE_RESIZABLE_SHMEM
+	ereport(ERROR,
+			errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+			errmsg("resizable shared memory is not supported on this platform"));
+#else
+
+	if (!AnonymousShmem)
+		ereport(ERROR,
+				errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+				errmsg("only anonymous shared memory can be protected at runtime"));
+
+#ifdef USE_ASSERT_CHECKING
+	{
+		size_t		os_page_size = GetOSPageSize();
+
+		Assert(rw_start == (void *) TYPEALIGN(os_page_size, rw_start));
+		Assert(rw_end == (void *) TYPEALIGN(os_page_size, rw_end));
+		Assert(prot_end == (void *) TYPEALIGN(os_page_size, prot_end));
+	}
+#endif
+	Assert(rw_end >= rw_start);
+
+	if (rw_end > rw_start)
+	{
+		if (mprotect(rw_start, (char *) rw_end - (char *) rw_start,
+					 PROT_READ | PROT_WRITE) != 0)
+		{
+			ereport(WARNING, errmsg("could not protect shared memory: %m"));
+			return false;
+		}
+	}
+
+	if (prot_end > rw_end)
+	{
+		if (mprotect(rw_end, (char *) prot_end - (char *) rw_end,
+					 PROT_NONE) != 0)
+		{
+			ereport(WARNING, errmsg("could not protect shared memory: %m"));
+			return false;
+		}
+	}
+
+	return true;
+#endif
+}
diff --git a/src/backend/port/win32_shmem.c b/src/backend/port/win32_shmem.c
index 794e4fcb2ad..d266cdbe226 100644
--- a/src/backend/port/win32_shmem.c
+++ b/src/backend/port/win32_shmem.c
@@ -200,11 +200,13 @@ EnableLockPagesPrivilege(int elevel)
 /*
  * PGSharedMemoryCreate
  *
- * Create a shared memory segment of the given size and initialize its
- * standard header.
+ * Create a shared memory segment of the given size and initialize its standard
+ * header. initial_size is only relevant when we want to create a larger memory
+ * segment with only a part of it being allocated initially. We don't support
+ * that on Windows, so we ignore it.
  */
 PGShmemHeader *
-PGSharedMemoryCreate(Size size,
+PGSharedMemoryCreate(Size initial_size, Size size,
 					 PGShmemHeader **shim)
 {
 	void	   *memAddress;
@@ -648,3 +650,59 @@ check_huge_page_size(int *newval, void **extra, GucSource source)
 	}
 	return true;
 }
+
+/*
+ * Get the page size used by the shared memory.
+ *
+ * The function should be called only after the shared memory has been setup.
+ */
+size_t
+GetOSPageSize(void)
+{
+	SYSTEM_INFO sysinfo;
+	size_t		os_page_size;
+
+	Assert(huge_pages_status != HUGE_PAGES_UNKNOWN);
+
+	GetSystemInfo(&sysinfo);
+	os_page_size = sysinfo.dwPageSize;
+
+	/* If huge pages are actually in use, use huge page size */
+	if (huge_pages_status == HUGE_PAGES_ON)
+		GetHugePageSize(&os_page_size, NULL);
+
+	return os_page_size;
+}
+
+/*
+ * PGSharedMemoryEnsureFreed / PGSharedMemoryEnsureAllocated
+ *
+ * Not supported on Windows.  These are only meaningful on platforms with
+ * resizable shared memory (mmap + madvise).
+ */
+bool
+PGSharedMemoryEnsureFreed(void *addr, Size size)
+{
+	ereport(ERROR,
+			errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+			errmsg("resizable shared memory is not supported on this platform"));
+	return false;				/* keep compiler quiet */
+}
+
+bool
+PGSharedMemoryEnsureAllocated(void *addr, Size size)
+{
+	ereport(ERROR,
+			errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+			errmsg("resizable shared memory is not supported on this platform"));
+	return false;				/* keep compiler quiet */
+}
+
+bool
+PGSharedMemoryProtect(void *rw_start, void *rw_end, void *prot_end)
+{
+	ereport(ERROR,
+			errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+			errmsg("resizable shared memory is not supported on this platform"));
+	return false;				/* keep compiler quiet */
+}
diff --git a/src/backend/postmaster/auxprocess.c b/src/backend/postmaster/auxprocess.c
index ad4bf4bd2a8..07a3b5c5923 100644
--- a/src/backend/postmaster/auxprocess.c
+++ b/src/backend/postmaster/auxprocess.c
@@ -69,33 +69,43 @@ AuxiliaryProcessMainCommon(void)
 	BaseInit();
 
 	/*
-	 * Prevent consuming interrupts between setting ProcSignalInit and setting
-	 * the initial local data checksum value.  If a barrier is emitted, and
-	 * absorbed, before local cached state is initialized the state transition
-	 * can be invalid.
-	 */
-	HOLD_INTERRUPTS();
-
-	ProcSignalInit(NULL, 0);
-
-	/*
-	 * Initialize a local cache of the data_checksum_version, to be updated by
-	 * the procsignal-based barriers.
+	 * Prevent consuming interrupts between ProcSignalInit() and the
+	 * initialization of local states that are kept in sync with shared memory
+	 * via procsignal-based barriers. If a barrier is emitted, and absorbed,
+	 * before local cached state is initialized the state transition can be
+	 * invalid.
 	 *
-	 * This intentionally happens after initializing the procsignal, otherwise
-	 * we might miss a state change. This means we can get a barrier for the
-	 * state we've just initialized - but it can happen only once.
+	 * These initializations intentionally happen after ProcSignalInit(),
+	 * otherwise we might miss a state change. This means we may also receive
+	 * a barrier for the state we've just initialized, but it can happen only
+	 * once.
 	 *
 	 * The postmaster (which is what gets forked into the new child process)
-	 * does not handle barriers, therefore it may not have the current value
-	 * of LocalDataChecksumState value (it'll have the value read from the
-	 * control file, which may be arbitrarily old).
+	 * does not handle barriers, therefore its local states may not reflect
+	 * the current state of the shared memory.
 	 *
 	 * NB: Even if the postmaster handled barriers, the value might still be
 	 * stale, as it might have changed after this process forked.
 	 */
+	HOLD_INTERRUPTS();
+
+	ProcSignalInit(NULL, 0);
+
+	/*
+	 * LocalDataChecksumState inherited from Postmaster will have the value
+	 * read from the control file, which may be arbitrarily old. Update it.
+	 */
 	InitLocalDataChecksumState();
 
+	/*
+	 * Refresh per-backend protections for resizable shmem structures, in case
+	 * these structures have been resized since the startup. Structures are
+	 * expected to be kept in sync by respective subsystems using
+	 * procsignal-based barriers. But we modify their protections en-masse
+	 * here, rather than relying on individual subsystems to do it.
+	 */
+	ShmemReprotectResizableStructs();
+
 	RESUME_INTERRUPTS();
 
 	/*
diff --git a/src/backend/storage/ipc/ipci.c b/src/backend/storage/ipc/ipci.c
index e149a738c8d..e5f20c4603e 100644
--- a/src/backend/storage/ipc/ipci.c
+++ b/src/backend/storage/ipc/ipci.c
@@ -52,31 +52,50 @@ RequestAddinShmemSpace(Size size)
 /*
  * CalculateShmemSize
  *		Calculates the amount of shared memory needed.
+ *
+ *	- `initial` is the amount of memory needed when the server startup.
+ *  - `min` is the minimum amount of memory needed when all the resizable
+ *  structures are shrunk to their respective minimum sizes.
+ *  - `max` is the maximum amount of memory needed when all the resizable
+ *  structures are expanded to their respective maximum sizes. It is also the
+ *  size of address space that must be reserved for the shared memory segment.
+ *
+ * When no resizable structures are requested, all three totals are identical.
+ *
+ * We take some care to ensure that the total size request doesn't overflow
+ * size_t.  If this gets through, we don't need to be so careful during the
+ * actual allocation phase.
  */
-Size
-CalculateShmemSize(void)
+void
+CalculateShmemSize(size_t *initial, size_t *min, size_t *max)
 {
-	Size		size;
+	size_t		initial_req;
+	size_t		min_req;
+	size_t		max_req;
+	size_t		fixed_addins;
+
+	ShmemGetRequestedSize(&initial_req, &min_req, &max_req);
 
 	/*
 	 * Size of the Postgres shared-memory block is estimated via moderately-
 	 * accurate estimates for the big hogs, plus 100K for the stuff that's too
 	 * small to bother with estimating.
 	 *
-	 * We take some care to ensure that the total size request doesn't
-	 * overflow size_t.  If this gets through, we don't need to be so careful
-	 * during the actual allocation phase.
+	 * Also include additional requested shmem from preload libraries.
+	 *
+	 * These are not resizable, so they contribute equally to all three
+	 * totals.
 	 */
-	size = 100000;
-	size = add_size(size, ShmemGetRequestedSize());
-
-	/* include additional requested shmem from preload libraries */
-	size = add_size(size, total_addin_request);
+	fixed_addins = add_size(100000, total_addin_request);
 
-	/* might as well round it off to a multiple of a typical page size */
-	size = add_size(size, 8192 - (size % 8192));
+	*initial = add_size(initial_req, fixed_addins);
+	*min = add_size(min_req, fixed_addins);
+	*max = add_size(max_req, fixed_addins);
 
-	return size;
+	/* might as well round each off to a multiple of a typical page size */
+	*initial = add_size(*initial, 8192 - (*initial % 8192));
+	*min = add_size(*min, 8192 - (*min % 8192));
+	*max = add_size(*max, 8192 - (*max % 8192));
 }
 
 #ifdef EXEC_BACKEND
@@ -121,18 +140,24 @@ CreateSharedMemoryAndSemaphores(void)
 {
 	PGShmemHeader *shim;
 	PGShmemHeader *seghdr;
-	Size		size;
+	size_t		initial_size;
+	size_t		min_size;
+	size_t		max_size;
 
 	Assert(!IsUnderPostmaster);
 
 	/* Compute the size of the shared-memory block */
-	size = CalculateShmemSize();
-	elog(DEBUG3, "invoking IpcMemoryCreate(size=%zu)", size);
+	CalculateShmemSize(&initial_size, &min_size, &max_size);
+	elog(DEBUG3, "invoking IpcMemoryCreate(initial size=%zu, minimum size=%zu, maximum size=%zu)",
+		 initial_size, min_size, max_size);
 
 	/*
-	 * Create the shmem segment
+	 * Create the shmem segment.
+	 *
+	 * Reserve enough shared address space to accommodate every requested
+	 * structure grown to its maximum size.
 	 */
-	seghdr = PGSharedMemoryCreate(size, &shim);
+	seghdr = PGSharedMemoryCreate(initial_size, max_size, &shim);
 
 	/*
 	 * Make sure that huge pages are never reported as "unknown" while the
@@ -189,32 +214,49 @@ void
 InitializeShmemGUCs(void)
 {
 	char		buf[64];
-	Size		size_b;
-	Size		size_mb;
-	Size		hp_size;
+	size_t		initial_b;
+	size_t		min_b;
+	size_t		max_b;
+	size_t		hp_size;
+	size_t		size_mb;
 
-	/*
-	 * Calculate the shared memory size and round up to the nearest megabyte.
-	 */
-	size_b = CalculateShmemSize();
-	size_mb = add_size(size_b, (1024 * 1024) - 1) / (1024 * 1024);
+	CalculateShmemSize(&initial_b, &min_b, &max_b);
+
+	/* Round each size up to the nearest megabyte. */
+	size_mb = add_size(initial_b, (1024 * 1024) - 1) / (1024 * 1024);
 	sprintf(buf, "%zu", size_mb);
-	SetConfigOption("shared_memory_size", buf,
+	SetConfigOption("shared_memory_initial_size", buf,
 					PGC_INTERNAL, PGC_S_DYNAMIC_DEFAULT);
 
-	/*
-	 * Calculate the number of huge pages required.
-	 */
+	size_mb = add_size(min_b, (1024 * 1024) - 1) / (1024 * 1024);
+	sprintf(buf, "%zu", size_mb);
+	SetConfigOption("shared_memory_minimum_size", buf,
+					PGC_INTERNAL, PGC_S_DYNAMIC_DEFAULT);
+
+	size_mb = add_size(max_b, (1024 * 1024) - 1) / (1024 * 1024);
+	sprintf(buf, "%zu", size_mb);
+	SetConfigOption("shared_memory_maximum_size", buf,
+					PGC_INTERNAL, PGC_S_DYNAMIC_DEFAULT);
+
+	/* Calculate the number of huge pages required for each size. */
 	GetHugePageSize(&hp_size, NULL);
 	if (hp_size != 0)
 	{
-		Size		hp_required;
+		size_t		hp_required;
+
+		hp_required = initial_b / hp_size + (initial_b % hp_size != 0);
+		sprintf(buf, "%zu", hp_required);
+		SetConfigOption("shared_memory_initial_size_in_huge_pages", buf,
+						PGC_INTERNAL, PGC_S_DYNAMIC_DEFAULT);
+
+		hp_required = min_b / hp_size + (min_b % hp_size != 0);
+		sprintf(buf, "%zu", hp_required);
+		SetConfigOption("shared_memory_minimum_size_in_huge_pages", buf,
+						PGC_INTERNAL, PGC_S_DYNAMIC_DEFAULT);
 
-		hp_required = size_b / hp_size;
-		if (size_b % hp_size != 0)
-			hp_required = add_size(hp_required, 1);
+		hp_required = max_b / hp_size + (max_b % hp_size != 0);
 		sprintf(buf, "%zu", hp_required);
-		SetConfigOption("shared_memory_size_in_huge_pages", buf,
+		SetConfigOption("shared_memory_maximum_size_in_huge_pages", buf,
 						PGC_INTERNAL, PGC_S_DYNAMIC_DEFAULT);
 	}
 
